package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLRestriction_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLRestriction extends JNIObject  {
	
	/* @generated */
	protected ISLRestriction(long ptr) {
		/*** PROTECTED REGION ID(ISLRestriction_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLRestriction build(long ptr) {
		return new ISLRestriction(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLRestriction_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_restriction_input 
	 * 
	@take source_restr sink_restr
	 * @generated
	**/
	 public static ISLRestriction buildInput(ISLSet source_restr, ISLSet sink_restr) { 
		/*** PROTECTED REGION ID(static_isl_restriction_input) DISABLED START ***/
		ISLRestriction res;
		
		synchronized(LOCK) {
			checkParameters(source_restr, sink_restr);
			try {
				res = ISLRestriction.build(ISLNative.isl_restriction_input(getNativePtr(source_restr), getNativePtr(sink_restr)));
			} finally {
				taken(source_restr);
				taken(sink_restr);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_restriction_output 
	 * 
	@take source_restr
	 * @generated
	**/
	 public static ISLRestriction buildOutput(ISLSet source_restr) { 
		/*** PROTECTED REGION ID(static_isl_restriction_output) DISABLED START ***/
		ISLRestriction res;
		
		synchronized(LOCK) {
			checkParameters(source_restr);
			try {
				res = ISLRestriction.build(ISLNative.isl_restriction_output(getNativePtr(source_restr)));
			} finally {
				taken(source_restr);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_restriction_none 
	 * 
	@take source_map
	 * @generated
	**/
	 public static ISLRestriction buildNone(ISLMap source_map) { 
		/*** PROTECTED REGION ID(static_isl_restriction_none) DISABLED START ***/
		ISLRestriction res;
		
		synchronized(LOCK) {
			checkParameters(source_map);
			try {
				res = ISLRestriction.build(ISLNative.isl_restriction_none(getNativePtr(source_map)));
			} finally {
				taken(source_map);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_restriction_empty 
	 * 
	@take source_map
	 * @generated
	**/
	 public static ISLRestriction buildEmpty(ISLMap source_map) { 
		/*** PROTECTED REGION ID(static_isl_restriction_empty) DISABLED START ***/
		ISLRestriction res;
		
		synchronized(LOCK) {
			checkParameters(source_map);
			try {
				res = ISLRestriction.build(ISLNative.isl_restriction_empty(getNativePtr(source_map)));
			} finally {
				taken(source_map);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_restriction_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_restriction_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_restriction_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLRestriction_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
